#include <math.h>
#include <LEDA/basic.h>
#include <iostream.h>
#include <stdio.h>
#include <tcl.h>
#include <tk.h>
#include <stdlib.h>
#include <LEDA/string.h>
#include "tgl_obj.cpp"
 
// maximaler Wert fr die Erzeugung von c++ string
#define MAXSTR 50 // maximale laenge eines Attributstrings
#define MAXSTR2 100000 // maximale laenge eines Graphenstrings
#define PI 3.14159265359
// Hilfsfunktion - wandelt LEDA strings in c++ strings (char arrays);
void str2char(string s, char* c) {
for(int i=0;i<(s.length());i++) {
	c[i]=s[i];
}
c[(s.length())]=0;
} 
// **********************************
// ** Hasthables
// **********************************
class Tgl_Hash {
public:
  Tcl_Interp* interp;
  Tcl_HashTable graphTable;
  Tcl_HashTable selectionTable;
  // Konstruktor
  Tgl_Hash() {
    // Tables initialisieren
    Tcl_InitHashTable(&graphTable, TCL_STRING_KEYS);
    Tcl_InitHashTable(&selectionTable, TCL_STRING_KEYS);
  }
  // Liefert zum Tcl-Objektnamen name die Adresse des C-Objekts
  // Graph
  Tgl_Graph* get_graph(Tcl_Interp * interp, char *name) {
    Tcl_HashEntry *entryPtr;
    entryPtr = Tcl_FindHashEntry(&graphTable, name);
    if (entryPtr == NULL) {
      return NULL;
    } else {
      return (Tgl_Graph*) Tcl_GetHashValue(entryPtr);
    }
  }
  // Selection
  Tgl_Selection* get_selection(Tcl_Interp *interp, char *name) {
    Tcl_HashEntry *entryPtr;
    entryPtr = Tcl_FindHashEntry(&selectionTable, name);
    if (entryPtr == NULL) {
      return NULL;
    } else {
      return (Tgl_Selection*) Tcl_GetHashValue(entryPtr);
    }
  }
};
// globale Initialisierung der Hashtables
Tgl_Hash hash;

int statsCmd(ClientData client, Tcl_Interp *interp, int argc, char *argv[]) {
  if (argc<2) {
    interp->result="ERROR:stats for (s)electionTable or (g)raphTable ?";
    return TCL_ERROR;
  }
  if (strcmp(argv[1],"g")==0) {
    interp->result=Tcl_HashStats(&(hash.graphTable));
  } else {
    interp->result=Tcl_HashStats(&(hash.selectionTable));
  }
  return TCL_OK;
}

int selectionsCmd(ClientData client, Tcl_Interp *interp, int argc,
		  char *argv[]) {
  Tcl_HashEntry* entry;
  Tcl_HashSearch search;
  string_ostream str;
  string s;
  char c[MAXSTR2];
  entry=Tcl_FirstHashEntry(&(hash.selectionTable),&search);
  str << "defined():"<< endl;
  while(entry!=NULL){
    str << Tcl_GetHashKey(&(hash.selectionTable),entry);
    entry=Tcl_NextHashEntry(&search);
    str << " ";
  }
  str << " ;" << endl;
  s=str.str();
  // Abschneiden dieser geisterhaften Restzeichen am Ende (LEDAbug?)
  for(int i=s.length();i!=0;i--){
    if (s[i]==';') {
      s=s.del(i+1,s.length());
      break;
    }
  }
  str2char(s,c);
  interp->result=c;
  return TCL_OK;
}

int gyCmd(ClientData client, Tcl_Interp *interp, int argc, char *argv[]) {
  if (argc<2) {
    interp->result="ERROR:missing arguments for gy";
    return TCL_ERROR;
  }
  if (strcmp(argv[1],"calc_edge")==0) {
    if (argc<10) {
      interp->result="ERROR:missing arguments for gy calc_edge";
      return TCL_ERROR; 
    } else {
      char erg[80];
      double fromx,fromy,tox,toy,nodesize,zoom,pos,edgespace;
      double betr,fromergx,fromergy,rotx,roty,toergx,toergy,midx,midy;
      double alpha,rotbetr;
      Tcl_GetDouble(interp,argv[2], &fromx);
      Tcl_GetDouble(interp,argv[3], &fromy);
      Tcl_GetDouble(interp,argv[4], &tox);
      Tcl_GetDouble(interp,argv[5], &toy);
      Tcl_GetDouble(interp,argv[6], &nodesize);
      Tcl_GetDouble(interp,argv[7], &zoom);
      Tcl_GetDouble(interp,argv[8], &pos );
      Tcl_GetDouble(interp,argv[9], &edgespace );


      betr=sqrt((tox-fromx)*(tox-fromx)+(toy-fromy)*(toy-fromy));
      toergy=toy-((toy-fromy)*(nodesize*zoom)/betr);
      toergx=tox-((tox-fromx)*(nodesize*zoom)/betr);
      fromergy=fromy-((fromy-toy)*(nodesize*zoom)/betr);
      fromergx=fromx-((fromx-tox)*(nodesize*zoom)/betr);
      
      midx=fromergx+(toergx-fromergx)*0.5;
      midy=fromergy+(toergy-fromergy)*0.5;
      alpha= asin((toergy-fromergy)/betr);
      rotx= midx+(toergx-midx)*cos(PI/2)-(toergy-midy)*sin(PI/2);
      roty= midy+(toergx-midx)*sin(PI/2)+(toergy-midy)*cos(PI/2);
      rotbetr=sqrt((rotx-fromergx)*(rotx-fromergx)+(roty-fromergy)
		   +(roty-fromergy));
      rotx= midx+edgespace*(ceil(pos/2)*pow(-1,pos))*zoom*(rotx-midx)/betr;
      roty= midy+edgespace*(ceil(pos/2)*pow(-1,pos))*zoom*(roty-midy)/betr;


      sprintf(erg,"%d",(int)fromergx);Tcl_AppendElement(interp,erg);
      sprintf(erg,"%d",(int)fromergy);Tcl_AppendElement(interp,erg);
      sprintf(erg,"%d",(int)rotx);Tcl_AppendElement(interp,erg);
      sprintf(erg,"%d",(int)roty);Tcl_AppendElement(interp,erg);
      sprintf(erg,"%d",(int)toergx);Tcl_AppendElement(interp,erg);
      sprintf(erg,"%d",(int)toergy);Tcl_AppendElement(interp,erg);
   
      return TCL_OK;
    }
  }
  return TCL_ERROR;
}

// *********************************
// *********************************
// *****     tgl-Kommandos    ****** 
// *********************************
// *********************************
// graph (Deklaration)
int graphObjCmd(ClientData client, Tcl_Interp* interp, int argc, char *argv[]);
int graphCmd(ClientData client, Tcl_Interp *interp, int argc, char *argv[]);
void graphDel(ClientData client);
// selection (Deklaration)
int selectionObjCmd(ClientData client, Tcl_Interp* interp, int argc,
		    char *argv[]);
void selectionDel(ClientData client);

// **********************************
// ** Graph + Cmd + ObjCmd + Del
// **********************************
void graphDel(ClientData client) {
  Tgl_Graph* G=(Tgl_Graph*) client;
  Tgl_Selection* S;
  list_item item;
  
  Tcl_HashEntry* entry;
  Tcl_HashSearch search;
  char* key;
  // in der Selections Hashtabelle alle zum Graphen gehrenden Eintraege
  // lschen
  entry=Tcl_FirstHashEntry(&(hash.selectionTable), &search);
  while(entry!=NULL){
    item=G->selections.search((Tgl_Selection*)Tcl_GetHashValue(entry));
    if (item!=0) {
      key=Tcl_GetHashKey(&(hash.selectionTable), entry);
      Tcl_DeleteCommand(hash.interp, key);
    }
    entry=Tcl_NextHashEntry(&search);
  }
  // internes C-Objekt zerstren
  delete ((Tgl_Graph*) client);
}

int graphCmd(ClientData client, Tcl_Interp *interp, int argc, char *argv[]) {
  Tgl_Graph* G;
  Tcl_HashEntry *entryPtr;
  int n;
  // Keine weiteren Argumente erlaubt!
  if (argc!=1) {
    interp->result = "wrong # args";
    return TCL_ERROR;
  }
  // Objekt erzeugen
  G = new Tgl_Graph;
  // Tcl Kommando generieren und mit graphObjCmd verbinden
  sprintf(interp->result, "g%d", G->id.get());
  Tcl_CreateCommand (interp, interp->result, graphObjCmd, (ClientData) G, 
		     graphDel);
  // Hashtableeintrag vornehmen
  entryPtr = Tcl_CreateHashEntry(&(hash.graphTable), interp->result, &n);
  Tcl_SetHashValue(entryPtr, G);
  return TCL_OK;
}

int graphObjCmd(ClientData client, Tcl_Interp* interp, int argc, char *argv[]) {
  Tgl_Graph *G = (Tgl_Graph*) client;
  // Kein Befehl -> print
  if (argc<2) {
    string_ostream str;
    string s;
    char* c=new char[MAXSTR2];
    str << *G << endl;
    s=str.str();
    // Abschneiden dieser geisterhaften Restzeichen am Ende (LEDAbug?)
    for(int i=s.length();i!=0;i--){
      if (s[i]==']') {
	s=s.del(i+1,s.length());
	break;
      }
    }
    if (s.length()>=MAXSTR2) {
      interp->result="Allgemeine Schutzverletzung in MODUL '$[graph] print!'";
      return TCL_ERROR;
    } else {
      str2char(s,c); 
      Tcl_SetResult(interp,c,TCL_DYNAMIC);
      return TCL_OK;
    }
  }
  // Parsing der Kommandos
  // clone
  if (strcmp(argv[1], "clone")==0) {
    int n;
    Tcl_HashEntry* entryPtr;
    Tgl_Graph* copyG = new Tgl_Graph(*G);
    sprintf(interp->result, "g%d", G->id.get());
    Tcl_CreateCommand(interp, interp->result, graphObjCmd, (ClientData) copyG,
		      graphDel);
    // Hashtableeintrag vornehmen
    entryPtr = Tcl_CreateHashEntry(&(hash.graphTable), interp->result, &n);
    Tcl_SetHashValue(entryPtr, G);
    return TCL_OK;
  }
  // clear
  if ((strcmp(argv[1],"clear"))==0) {
    Tgl_Selection Sall(G);
    for(int i=0;i<G->count_nodes();i++) {
      Sall.add_node(i);
    }
    for(i=0;i<G->count_edges();i++) {
      Sall.add_edge(i);
    }
    Sall.erase();
    interp->result = "... cleared (graph)";
    return TCL_OK;
  }
  // *** delete ...
  if ((strcmp(argv[1],"delete"))==0) {
    // delete Graph
    if (argc<3) {
      // Tcl-Kommando entfernen
      // (Tcl ruft graphDel automatisch auf
      Tcl_DeleteCommand(interp, argv[0]);
      // Hashtable Eintrag lschen
      Tcl_HashEntry *entryPtr;
      entryPtr = Tcl_FindHashEntry(&hash.graphTable, argv[0]);
      Tcl_DeleteHashEntry(entryPtr);
      interp->result = "... deleted (graph)";
      return TCL_OK;
    }
    // delete node_attribute
    if ((strcmp(argv[2],"node_attribute"))==0 
	|| (strcmp(argv[2],"node_attr")==0))  {
      if (argc<4) {
	interp->result="ERROR:missing node_attribute name";
	  return TCL_ERROR;
      }
      G->delete_node_attribute(argv[3]);
      cout << argv[3] << endl;
      interp->result="... deleted (node_attribute)";
      return TCL_OK;
    }
    if ((strcmp(argv[2],"edge_attribute"))==0 
	|| (strcmp(argv[2],"edge_attr")==0)) {
      if (argc<4) {
	interp->result="ERROR:missing edge_attribute name";
	  return TCL_ERROR;
      }
      G->delete_edge_attribute(argv[3]);
      interp->result="... deleted (edge_attribute)";
      return TCL_OK;
    }
      
  } // ... delete *** 
  // print
  if (strcmp(argv[1],"print")==0) {
    string_ostream str;
    string s;
    char* c=new char[MAXSTR2];
    str << *G << endl;
    s=str.str();
    // Abschneiden dieser geisterhaften Restzeichen am Ende (LEDAbug?)
    for(int i=s.length();i!=0;i--){
      if (s[i]==']') {
	s=s.del(i+1,s.length());
	break;
      }
    }
    if (s.length()>=MAXSTR2) {
      interp->result="Allgemeine Schutzverletzung in MODUL '$[graph] print!'";
      return TCL_ERROR;
    } else {
      str2char(s,c); 
      Tcl_SetResult(interp,c,TCL_DYNAMIC);
      return TCL_OK;
    }
  }
  // read
  if (strcmp(argv[1],"read")==0) {
    if (argc<3) { 
      interp->result="ERROR:missing filename";
      return TCL_ERROR;
    } else {
      if (G->read(argv[2])!=0) {
	interp->result="ERROR:IO Operation failed";
	return TCL_ERROR;
      } else {
	interp->result="... read";
	return TCL_OK;
      }
    }
  }
  // write
  if (strcmp(argv[1],"write")==0) {
    if (argc<3) { 
      interp->result="ERROR:missing filename";
      return TCL_ERROR;
    } else {
      if (G->write(argv[2])!=0) {
	interp->result="ERROR:IO Operation failed";
	return TCL_ERROR;
      } else {
	interp->result="... written";
	return TCL_OK;
      }
    } 
  }
  // *** new ..
  if (strcmp(argv[1],"new")==0) {
    if (argc<3) {
      interp->result="ERROR:missing objecttype for operation";
      return TCL_ERROR;
    }
    // selection
    if ((strcmp(argv[2],"selection")==0)||(strcmp(argv[2],"sel")==0)) {
      // Selection auf G erzeugen
      Tgl_Selection* S = new Tgl_Selection(G);
      // Tcl-Kommando fr Selection erzeugen
      sprintf(interp->result,"s%d", S->id.get());
      Tcl_CreateCommand(interp, interp->result, selectionObjCmd,
			(ClientData) S, selectionDel);
      // Hashtabelle aktualisieren
      int n;
      Tcl_HashEntry* entryPtr;
      entryPtr = Tcl_CreateHashEntry(&(hash.selectionTable),
				     interp->result, &n);
      Tcl_SetHashValue(entryPtr, S);
      return TCL_OK;
    }
    // node
    if ((strcmp(argv[2],"node")==0)) {
      // Selection mit Knoten erzeugen
      Tgl_Selection* S = G->new_node();
      // Tcl-Kommando fr Selection erzeugen
      sprintf(interp->result,"s%d", S->id.get());
      Tcl_CreateCommand(interp, interp->result, selectionObjCmd,
			(ClientData) S, selectionDel);
      // Hashtabelle aktualisieren
      int n;
      Tcl_HashEntry* entryPtr;
      entryPtr = Tcl_CreateHashEntry(&(hash.selectionTable),
				     interp->result, &n);
      Tcl_SetHashValue(entryPtr, S);
      return TCL_OK;
    }
    // edge
    if ((strcmp(argv[2],"edge")==0)) {
      if (argc<5) {
	interp->result="ERROR:not enough Arguments-missing source and/or target selection";
	return TCL_ERROR;
      }
      // Argumente erhashen 
      Tcl_HashEntry* fromEntry = Tcl_FindHashEntry(&(hash.selectionTable),
						  argv[3]);
      if (fromEntry == NULL) {
	interp->result="ERROR:unknown source selection";
	return TCL_ERROR;
      }
      Tcl_HashEntry* toEntry = Tcl_FindHashEntry(&(hash.selectionTable),
						  argv[4]);
      if (toEntry == NULL) {
	interp->result="ERROR:unknown target selection";
	return TCL_ERROR;
      }      
      Tgl_Selection* from = (Tgl_Selection*)Tcl_GetHashValue(fromEntry);
      Tgl_Selection* to = (Tgl_Selection*)Tcl_GetHashValue(toEntry);
      // Selection mit Kanten erzeugen
      Tgl_Selection* S = G->new_edge(*from,*to);
      // Tcl-Kommando fr Selection erzeugen
      sprintf(interp->result,"s%d", S->id.get());
      Tcl_CreateCommand(interp, interp->result, selectionObjCmd,
			(ClientData) S, selectionDel);
      // Hashtabelle aktualisieren
      int n;
      Tcl_HashEntry* entryPtr;
      entryPtr = Tcl_CreateHashEntry(&(hash.selectionTable),
				     interp->result, &n);
      Tcl_SetHashValue(entryPtr, S);
      return TCL_OK;
    }
    // node_attribute
    if ((strcmp(argv[2],"node_attribute"))==0 
	|| (strcmp(argv[2],"node_attr")==0)) {
      if (argc<4) {
	interp->result="ERROR:missing node_attribute name and generic value";
	return TCL_ERROR;
      }
      if (argc<5) {
	interp->result="ERROR:missing generic value for new node_attribute";
	return TCL_ERROR;
      }
      G->new_node_attribute(argv[3],argv[4]);
      interp->result="... created (node_attribute)";
      return TCL_OK;      
    }
    // edge_attribute
    if ((strcmp(argv[2],"edge_attribute"))==0 
	|| (strcmp(argv[2],"edge_attr")==0)) {
      if (argc<4) {
	interp->result="ERROR:missing edge_attribute name and generic value";
	return TCL_ERROR;
      }
      if (argc<5) {
	interp->result="ERROR:missing generic value for new edge_attribute";
	return TCL_ERROR;
      }
      G->new_edge_attribute(argv[3],argv[4]);
      interp->result="... created (edge_attribute)";
      return TCL_OK;      
    }
    interp->result="ERROR:unknown objecttype";
    return TCL_ERROR;
  } // ... new ***
  // *** count ...
  if (strcmp(argv[1],"count")==0) {
    if (argc<3) {
      interp->result="ERROR:missing objecttype for operation";
      return TCL_ERROR;
    }
    if (strcmp(argv[2],"nodes")==0) {
      sprintf(interp->result, "%d", G->count_nodes());
      return TCL_OK;
    }
    if (strcmp(argv[2],"edges")==0) {
      sprintf(interp->result, "%d", G->count_edges());
      return TCL_OK;
    }
    if ((strcmp(argv[2],"node_attributes")==0) 
      || (strcmp(argv[2],"node_attr")==0))  {
      sprintf(interp->result, "%d", G->count_node_attributes());
      return TCL_OK;
    }
    if ((strcmp(argv[2],"edge_attributes")==0)
      || (strcmp(argv[2],"edge_attr")==0)) {
      sprintf(interp->result, "%d", G->count_edge_attributes());
      return TCL_OK;
    }
    interp->result="ERROR:unknown objecttype";
    return TCL_ERROR;
  } // ... count *** 
  // node_attribute NR
  if ((strcmp(argv[1],"node_attribute"))==0 
      || (strcmp(argv[1],"node_attr")==0)) {
    if (argc<3) {
      interp->result="ERROR:missing index argument";
      return TCL_ERROR;
    }
    int n;
    if (Tcl_GetInt(interp, argv[2], &n)!=TCL_OK) {
      interp->result="ERROR:index argument is not an integer";
      return TCL_ERROR;
    }
    if ((n>=G->count_node_attributes()) || (n<0)) {
      interp->result="ERROR:index exceeds maximum number of node_attributes";
      return TCL_ERROR;
    }
    char c[MAXSTR];
    str2char(G->get_node_attribute(n),c);
    interp->result=c;
    return TCL_OK;
  }
  // edge_attribute NR
  if ((strcmp(argv[1],"edge_attribute"))==0 
      || (strcmp(argv[1],"edge_attr")==0)) {
    if (argc<3) {
      interp->result="ERROR:missing index argument";
      return TCL_ERROR;
    }
    int n;
    if (Tcl_GetInt(interp, argv[2], &n)!=TCL_OK) {
      interp->result="ERROR:index argument is not an integer";
      return TCL_ERROR;
    }
    if ((n>=G->count_edge_attributes()) || (n<0)) {
      interp->result="ERROR:index exceeds maximum number of edge_attributes";
      return TCL_ERROR;
    }
    char c[MAXSTR];
    str2char(G->get_edge_attribute(n),c);
    interp->result=c;
    return TCL_OK;
  }
  if ((strcmp(argv[1],"rename")==0) 
    || (strcmp(argv[1],"name")==0))  {
    if (argc<3) {
      char c[MAXSTR];
      str2char(G->name,c);
      interp->result=c;
      return TCL_OK;
    }
    G->name=argv[2];
    interp->result="... renamed";
    return TCL_OK;
  }
  // join 
  if ((strcmp(argv[1],"join")==0)) {
    if (argc<3) {
      interp->result="ERROR:missing graph to join with";
      return TCL_ERROR;
    }
    Tgl_Graph* Gjoin;
    Tcl_HashEntry* entry=Tcl_FindHashEntry(&(hash.graphTable),argv[2]);
    if (entry==NULL) {
      interp->result="ERROR:unknown graph to join with";
      return TCL_ERROR;
    }
    Gjoin=(Tgl_Graph*)Tcl_GetHashValue(entry);
    G->join(*Gjoin);
    interp->result="... joined";
    return TCL_OK;
  }
  // paste 
  if ((strcmp(argv[1],"paste")==0)) {
    if (argc<3) {
      interp->result="ERROR:missing selection to paste and result selection";
      return TCL_ERROR;
    }
    if (argc<4) {
      interp->result="ERROR:missing result selection";
      return TCL_ERROR;
    }
    // Selections ermitteln
    // paste Selection
    Tgl_Selection* pasteS;
    Tcl_HashEntry* entry=Tcl_FindHashEntry(&(hash.selectionTable),argv[2]);
    if (entry==NULL) {
      interp->result="ERROR:unknown selection to paste";
      return TCL_ERROR;
    }
    pasteS=(Tgl_Selection*)Tcl_GetHashValue(entry);
    // result Selection
    Tgl_Selection* ergS;
    entry=Tcl_FindHashEntry(&(hash.selectionTable),argv[3]);
    if (entry==NULL) {
      interp->result="ERROR:unknown selection to paste";
      return TCL_ERROR;
    }
    ergS=(Tgl_Selection*)Tcl_GetHashValue(entry);
    // paste Selection und result Selection drfen nicht gleich sein
    if (ergS==pasteS) {
      cout << "#" << ergS << "#" << pasteS << "#" << endl;
      interp->result="ERROR:paste and result selection may not be the same ";
      return TCL_ERROR;
    }
    G->paste(*pasteS,*ergS);
    interp->result="... pasted";
    return TCL_OK;  
  }

  // kein gltiges Komando
  interp->result = "ERROR:bad graph command";
  return TCL_ERROR;
}

// **********************************
// ** Selection + Cmd + ObjCmd + Del
// **********************************
void selectionDel(ClientData client) {
  // Hashtable Eintrag lschen
  Tcl_HashEntry* entry;

  Tcl_HashSearch search;
  char key[MAXSTR];
  list_item item;
  // in der Selections Hashtabelle Eintrag ber Value suchen
  entry=Tcl_FirstHashEntry(&(hash.selectionTable), &search);
  while(entry!=NULL){
    if ((Tgl_Selection*)Tcl_GetHashValue(entry)==(Tgl_Selection*)client) {
      break;
    }
    entry=Tcl_NextHashEntry(&search);
  }
  if (entry==NULL) {
    cout << "Allgemeine Schutzverletzung in Modul selectionDel" << endl;
  } else {
    Tcl_DeleteHashEntry(entry);
  }
  // internes C-Objekt zerstren
  delete ((Tgl_Selection*) client);
}
int selectionObjCmd(ClientData client, Tcl_Interp* interp, int argc,
		    char *argv[]) {
  Tgl_Selection *S = (Tgl_Selection*) client;
  // kein Befehl -> print
  if (argc<2) {
    string_ostream str;
    string s;
    char* c=new char[MAXSTR2];
    str << *S << endl;
    s=str.str();
    // Abschneiden dieser geisterhaften Restzeichen am Ende (LEDAbug?)
    for(int i=s.length();i!=0;i--){
      if (s[i]==';') {
	s=s.del(i+1,s.length());
	break;
     }
    }
    if (s.length()>=MAXSTR2) {
      interp->result="Allgemeine Schutzverletzung in MODUL '$[graph] print!'";
      return TCL_ERROR;
    } else {
      str2char(s,c); 
      Tcl_SetResult(interp,c,TCL_DYNAMIC);
      return TCL_OK;
    }
  }
  // Parsing der Kommandos
  // clone
  if (strcmp(argv[1], "clone")==0) {
    int n;
    Tcl_HashEntry* entryPtr;
    Tgl_Selection* copyS = new Tgl_Selection(*S);
    sprintf(interp->result, "s%d", S->id.get());
    Tcl_CreateCommand(interp, interp->result, selectionObjCmd, 
		      (ClientData) copyS, selectionDel);
    // Hashtableeintrag vornehmen
    entryPtr = Tcl_CreateHashEntry(&(hash.selectionTable),
				   interp->result, &n);
    Tcl_SetHashValue(entryPtr, copyS);
    return TCL_OK;
  }
  // clear
  if (strcmp(argv[1],"clear")==0) {
    S->clear();
    interp->result = "... cleared";
    return TCL_OK;
  }
  // delete
  if ((strcmp(argv[1],"delete"))==0) {
    // Tcl-Kommando entfernen
    // (Tcl ruft graphDel automatisch auf
    Tcl_DeleteCommand(interp, argv[0]);
    interp->result = "... deleted";
    return TCL_OK;
  }
  // print
  if (strcmp(argv[1],"print")==0) {
    string_ostream str;
    string s;
    char* c=new char[MAXSTR2];
    str << *S << endl;
    s=str.str();
    // Abschneiden dieser geisterhaften Restzeichen am Ende (LEDAbug?)
    for(int i=s.length();i!=0;i--){
      if (s[i]==';') {
	s=s.del(i+1,s.length());
	break;
     }
    }
    if (s.length()>=MAXSTR2) {
      interp->result="Allgemeine Schutzverletzung in MODUL '$[graph] print!'";
      return TCL_ERROR;
    } else {
      str2char(s,c); 
      Tcl_SetResult(interp,c,TCL_DYNAMIC);
      return TCL_OK;
    }
  }
  // *** add/join ...
  if ((strcmp(argv[1],"add")==0) 
    || (strcmp(argv[1],"+")==0) ||
      (strcmp(argv[1],"join")==0)){  
    if (argc<3) {
      interp->result="ERROR:missing objecttype to add";
      return TCL_OK;
    }
    // node
    if (strcmp(argv[2],"node")==0) {
      if (argc<4) {
	interp->result="ERROR:mising index of node to add";
	return TCL_ERROR;
      }
      int n;
      if (Tcl_GetInt(interp, argv[3], &n)!=TCL_OK) {
	interp->result="ERROR:index argument is not an integer";
	return TCL_ERROR;
      }
      if (n>=S->of->count_nodes()) {
	interp->result="ERROR:index* exceeds maximum number of nodes";
	return TCL_ERROR;	
      }
      S->add_node(n);
      interp->result="... node added";
      return TCL_OK;      
    }
    // edge
    if (strcmp(argv[2],"edge")==0) {
      if (argc<4) {
	interp->result="ERROR:mising index of edge to add";
	return TCL_ERROR;
      }
      int n;
      if (Tcl_GetInt(interp, argv[3], &n)!=TCL_OK) {
	interp->result="ERROR:index argument is not an integer";
	return TCL_ERROR;
      }
      if (n>=S->of->count_edges()) {
	interp->result="ERROR:index exceeds maximum number of edges";
	return TCL_ERROR;	
      }
      S->add_edge(n);
      interp->result="... edge added";
      return TCL_OK;      
    }
    // all
    if (strcmp(argv[2],"all")==0) {
      for(int i=0;i<S->of->count_nodes();i++) {
	S->add_node(i);
      }
      for(i=0;i<S->of->count_edges();i++) {
	S->add_edge(i);
      }
      interp->result="... added all";
      return TCL_OK;
    }
    // selection
    // else .. argv[2] ist Selection
    Tgl_Selection* SS;
    Tcl_HashSearch* search;
    Tcl_HashEntry* entry=Tcl_FindHashEntry(&(hash.selectionTable),argv[2]);
    SS=(Tgl_Selection*)Tcl_GetHashValue(entry);
    if (entry==NULL) {
      interp->result="ERROR:unknown selection";
      return TCL_ERROR;
    }
    // oder nur ein Element der Selection adden?
    if (argc>3){
      // node
      if (strcmp(argv[3],"node")==0) {
	if (argc<5) {
	  interp->result="ERROR:mising index of node to add";
	  return TCL_ERROR;
	}
	int n;
	if (Tcl_GetInt(interp, argv[4], &n)!=TCL_OK) {
	  interp->result="ERROR:index argument is not an integer";
	  return TCL_ERROR;
	}
	if ((n>=(SS->count_nodes())) || (n<0)) {
	  interp->result="ERROR:index exceeds maximum number of nodes in selection";
	  return TCL_ERROR;
	}
	S->add(SS->node_nr(n));
	interp->result="... added (node from selection)";
	return TCL_OK;
      }
      // edge
      if (strcmp(argv[3],"edge")==0) {
	if (argc<5) {
	  interp->result="ERROR:mising index of edge to add";
	  return TCL_ERROR;
	}
	int n;
	if (Tcl_GetInt(interp, argv[4], &n)!=TCL_OK) {
	  interp->result="ERROR:index argument is not an integer";
	  return TCL_ERROR;
	}
	if ((n>=(SS->count_edges())) || (n<0)) {
	  interp->result="ERROR:index exceeds maximum number of edges in selection";
	  return TCL_ERROR;
	}
	S->add(SS->edge_nr(n));
	interp->result="... added (edge from selection)";
	return TCL_OK;
      }
    } else { // komplette Selection addieren
      S->add(*SS);
      interp->result="... added (selection)";
      return TCL_OK;
    }
  } // ... add ***
  // erase
  if (strcmp(argv[1],"erase")==0) {  
    S->erase();

    // jetzt noch den Hashtable aufraeumen
    // dazu alle in ihm enthaltenen Objekt auf xistenz berprfen
    Tcl_HashEntry* entry;

    Tcl_HashSearch search;
    char *key= new char[MAXSTR];
    list_item item;
    interp->result="... erased from Graph";
    return TCL_OK;
  }
  // clear
  if (strcmp(argv[1],"clear")==0) {  
    S->clear();
    interp->result="... cleared";
    return TCL_OK;
  }
  // *** count ...
  if (strcmp(argv[1],"count")==0) {
    if (argc<3) {
      interp->result="ERROR:missing objecttype for operation";
      return TCL_ERROR;
    }
    if (strcmp(argv[2],"nodes")==0) {
      sprintf(interp->result, "%d", S->count_nodes());
      return TCL_OK;
    }
    if (strcmp(argv[2],"edges")==0) {
      sprintf(interp->result, "%d", S->count_edges());
      return TCL_OK;
    }
    interp->result="ERROR:unknown objecttype";
    return TCL_ERROR;
  } // ... count *** 
  // *** set ...
  if (strcmp(argv[1],"set")==0) {
    if (argc<3) {
      interp->result="ERROR:missing objecttype for operation";
      return TCL_ERROR;
    }
    // node_attribute
    if ((strcmp(argv[2],"node_attribute")==0) 
	|| (strcmp(argv[2],"node_attr")==0)){
      if (argc<4) {
	interp->result="ERROR:missing node_attribute name and value";
	return TCL_ERROR;
      }
      if (argc<5) {
	interp->result="ERROR:missing value for node_attribute";
	return TCL_ERROR;
      }
      if (argc<6) {
	S->set_node_attribute(argv[3],argv[4]);
	interp->result="... set (node_attributes)";
	return TCL_OK;
      } else {
	int n;
	if (Tcl_GetInt(interp, argv[5], &n)!=TCL_OK) {
	  interp->result="ERROR:index argument is not an integer";
	  return TCL_ERROR;
	}
	if ((n>=(S->count_nodes())) || (n<0)) {
	  interp->result="ERROR:index exceeds maximum number of nodes in selection";
	  return TCL_ERROR;
	}
	S->set_one_node_attribute(argv[3],argv[4],n);
	interp->result="... set (one node_attribute)";
	return TCL_OK;
      }
    }
    // edge_attribute
    if ((strcmp(argv[2],"edge_attribute"))==0 
	|| (strcmp(argv[2],"edge_attr")==0)){
      if (argc<4) {
	interp->result="ERROR:missing edge_attribute name and value";
	return TCL_ERROR;
      }
      if (argc<5) {
	interp->result="ERROR:missing value for edge_attribute";
	return TCL_ERROR;
      }
      if (argc<6) {
	S->set_edge_attribute(argv[3],argv[4]);
	interp->result="... set (edge_attributes)";
	return TCL_OK;
      } else {
	int n;
	if (Tcl_GetInt(interp, argv[5], &n)!=TCL_OK) {
	  interp->result="ERROR:index argument is not an integer";
	  return TCL_ERROR;
	}
	if ((n>=(S->count_edges())) || (n<0)) {
	  interp->result="ERROR:index exceeds maximum number of edges in selection";
	  return TCL_ERROR;
	}
	S->set_one_edge_attribute(argv[3],argv[4],n);
	interp->result="... set (one edge_attribute)";
	return TCL_OK;
      }
    }
    interp->result="ERROR:unknown objecttype";
    return TCL_ERROR;
  } // ... set ***  
  // *** get ...
  if (strcmp(argv[1],"get")==0) {
    if (argc<3) {
      interp->result="ERROR:missing objecttype";
      return TCL_ERROR;
    }
    // get ... node_attribute
    if ((strcmp(argv[2],"node_attribute"))==0 
	|| (strcmp(argv[2],"node_attr")==0)) {
      if (argc<4) {
	interp->result="ERROR:missing node_attribute name";
	return TCL_ERROR;
      }
      int n;
      // kein Index angegeben -> 0 annehmen
      if (argc<5) { 
	n=0;
      } else { 
	if (Tcl_GetInt(interp, argv[4], &n)!=TCL_OK) {
	  interp->result="ERROR:index argument is not an integer";
	  return TCL_ERROR;
	}
      }
      if ((n>=S->count_nodes()) || (n<0)) {
	interp->result="ERROR:index exceeds maximum number of nodes";
	return TCL_ERROR;
      }
      char c[MAXSTR];
      str2char(S->get_node_attribute(argv[3],n),c);
      interp->result=c;
      return TCL_OK;
    }
    // get ... edge_attribute
    if ((strcmp(argv[2],"edge_attribute"))==0 
	|| (strcmp(argv[2],"edge_attr")==0)) {
      if (argc<4) {
	interp->result="ERROR:missing edge_attribute name";
	return TCL_ERROR;
      }
      int n;
      // kein Index angegeben -> 0 annehmen
      if (argc<5) { 
	n=0;
      } else { 
	if (Tcl_GetInt(interp, argv[4], &n)!=TCL_OK) {
	  interp->result="ERROR:index argument is not an integer";
	  return TCL_ERROR;
	}
      }
      if ((n>=S->count_edges()) || (n<0)) {
	interp->result="ERROR:index exceeds maximum number of edges";
	return TCL_ERROR;
      }
      char c[MAXSTR];
      str2char(S->get_edge_attribute(argv[3],n),c);
      interp->result=c;
      return TCL_OK;
    }
    // get ... graph
    if ((strcmp(argv[2],"graph"))==0) {
      // Graph-Hashtable nach S->of durchsuchen
      Tcl_HashEntry* entry;
      Tcl_HashSearch search;
      char key[MAXSTR];
      list_item item;
      entry=Tcl_FirstHashEntry(&(hash.graphTable), &search);
      while(entry!=NULL){
	if ((Tgl_Graph*)Tcl_GetHashValue(entry)==(S->of)) {
	  break;
	}
	entry=Tcl_NextHashEntry(&search);
      }
      if (entry==NULL) {
	interp->result= "ERROR:Allgemeine Schutzverletzung in Modul get graph";
	return TCL_ERROR;
      } else {
	interp->result=Tcl_GetHashKey(&(hash.graphTable),entry);
	return TCL_OK;
      }
    }
  }
  // *** select ...
  if (strcmp(argv[1],"select")==0) {
    if (argc<3) {
      interp->result="ERROR:missing Objecttype to select";
      return TCL_ERROR;
    }
    // nodes
    if (strcmp(argv[2],"nodes")==0) {
      S->select_nodes();
      interp->result="... selected nodes";
      return TCL_OK;
    }
    // edges
    if (strcmp(argv[2],"edges")==0) {
      S->select_edges();
      interp->result="... selected edges";
      return TCL_OK;
    }
    // sources
    if (strcmp(argv[2],"sources")==0) {
      S->select_sources();
      interp->result="... selected sources";
      return TCL_OK;
    }
    // targets
    if (strcmp(argv[2],"targets")==0) {
      S->select_targets();
      interp->result="... selected targets";
      return TCL_OK;
    }
    // ins
    if (strcmp(argv[2],"ins")==0) {
      S->select_ins();
      interp->result="... selected ins";
      return TCL_OK;
    }
    // outs
    if (strcmp(argv[2],"outs")==0) {
      S->select_outs();
      interp->result="... selected outs";
      return TCL_OK;
    }
    // ins&outs
    if (strcmp(argv[2],"ins&outs")==0) {
      S->select_ins_outs();
      interp->result="... selected ins&outs";
      return TCL_OK;
    }
    // node_attribute
    if ((strcmp(argv[2],"node_attribute")==0)
      || (strcmp(argv[2],"node_attr")==0)) {
	if (argc<4) {
	  interp->result="ERROR:missing node_attribute name and value";
	  return TCL_ERROR;
	}
	if (argc<5) {
	  interp->result="ERROR:missing node_attribute value";
	  return TCL_ERROR;
	}
	S->select_node_attribute(argv[3],argv[4]);
	interp->result="... selected";
	return TCL_OK;
    }
    // edge_attribute
    if ((strcmp(argv[2],"edge_attribute")==0)
      || (strcmp(argv[2],"edge_attr")==0)) {
	if (argc<4) {
	  interp->result="ERROR:missing edge_attribute name and value";
	  return TCL_ERROR;
	}
	if (argc<5) {
	  interp->result="ERROR:missing edge_attribute value";
	  return TCL_ERROR;
	}
	S->select_edge_attribute(argv[3],argv[4]);
	interp->result="... selected";
	return TCL_OK;
    }
  }
  // intersect
  if ((strcmp(argv[1],"intersect")==0) 
    || (strcmp(argv[1],"&")==0))  {  
    if (argc<3) {
      interp->result="ERROR:missing selection";
      return TCL_OK;
    }
    Tgl_Selection* SS;
    Tcl_HashSearch* search;
    Tcl_HashEntry* entry=Tcl_FindHashEntry(&(hash.selectionTable),argv[2]);
    if (entry==NULL) {
      interp->result="ERROR:unknown selection";
      return TCL_ERROR;
    }
    SS=(Tgl_Selection*)Tcl_GetHashValue(entry);
    S->intersect(*SS);
    interp->result="... done";
    return TCL_OK;
  }  
  // setminus
  if ((strcmp(argv[1],"setminus")==0) 
    || (strcmp(argv[1],"-")==0) 
      || (strcmp(argv[1],"remove")==0)) {  
    if (argc<3) {
      interp->result="ERROR:missing selection";
      return TCL_OK;
    }
    Tgl_Selection* SS;
    Tcl_HashSearch* search;
    Tcl_HashEntry* entry=Tcl_FindHashEntry(&(hash.selectionTable),argv[2]);
    if (entry==NULL) {
      interp->result="ERROR:unknown selection";
      return TCL_ERROR;
    }
    SS=(Tgl_Selection*)Tcl_GetHashValue(entry);
    S->setminus(*SS);
    interp->result="... setminus done";
    return TCL_OK;
  }
  // node NR
  if ((strcmp(argv[1],"node")==0)) {
    if (argc<3) {
      interp->result="ERROR:missing index argument";
      return TCL_ERROR;
    }
    int n;
    if (Tcl_GetInt(interp, argv[2], &n)!=TCL_OK) {
      interp->result="ERROR:index argument is not an integer";
      return TCL_ERROR;
    }
    if ((n>=(S->count_nodes())) || (n<0)) {
      interp->result="ERROR:index exceeds maximum number of nodes in selection";
      return TCL_ERROR;
    }    
    // Selection mit Knoten erzeugen
    Tgl_Selection* newS = new Tgl_Selection(S->of);
    newS->add(S->node_nr(n));
    // Tcl-Kommando fr Selection erzeugen
    sprintf(interp->result,"s%d", S->id.get());
    Tcl_CreateCommand(interp, interp->result, selectionObjCmd,
		      (ClientData) newS, selectionDel);
    // Hashtabelle aktualisieren
    int i;
    Tcl_HashEntry* entryPtr;
    entryPtr = Tcl_CreateHashEntry(&(hash.selectionTable),
				   interp->result, &i);
    Tcl_SetHashValue(entryPtr, newS);
    return TCL_OK;
  }
  // edge NR
  if ((strcmp(argv[1],"edge")==0)) {
    if (argc<3) {
      interp->result="ERROR:missing index argument";
      return TCL_ERROR;
    }
    int n;
    if (Tcl_GetInt(interp, argv[2], &n)!=TCL_OK) {
      interp->result="ERROR:index argument is not an integer";
      return TCL_ERROR;
    }
    if ((n>=(S->count_edges())) || (n<0)) {
      interp->result="ERROR:index exceeds maximum number of edges in selection";
      return TCL_ERROR;
    }    
    // Selection mit Knoten erzeugen
    Tgl_Selection* newS = new Tgl_Selection(S->of);
    newS->add(S->edge_nr(n));
    // Tcl-Kommando fr Selection erzeugen
    sprintf(interp->result,"s%d", S->id.get());
    Tcl_CreateCommand(interp, interp->result, selectionObjCmd,
		      (ClientData) newS, selectionDel);
    // Hashtabelle aktualisieren
    int i;
    Tcl_HashEntry* entryPtr;
    entryPtr = Tcl_CreateHashEntry(&(hash.selectionTable),
				   interp->result, &i);
    Tcl_SetHashValue(entryPtr, newS);
    return TCL_OK;
  }
  // kein gltiges Komando
  interp->result = "ERROR:bad selection command";
  return TCL_ERROR;
}

// **********************************
// ** Tgl Init
// **********************************
int Tgl_Init(Tcl_Interp * interp) {
  // Kommandos registrieren
  Tcl_CreateCommand(interp, "graph", graphCmd,
		    (ClientData *) NULL,
		    (Tcl_CmdDeleteProc *) NULL);
  Tcl_CreateCommand(interp, "selections", selectionsCmd,
		    (ClientData *) NULL,
		    (Tcl_CmdDeleteProc *) NULL);
  Tcl_CreateCommand(interp, "stats", statsCmd,
		    (ClientData *) NULL,
		    (Tcl_CmdDeleteProc *) NULL);
  Tcl_CreateCommand(interp, "sels", selectionsCmd,
		    (ClientData *) NULL,
		    (Tcl_CmdDeleteProc *) NULL);
  Tcl_CreateCommand(interp, "gy", gyCmd,
		    (ClientData *) NULL,
		    (Tcl_CmdDeleteProc *) NULL);
  return Tcl_EvalFile(interp, "init.tcl");
}


// **********************************
// ** Application
// **********************************
int Tcl_AppInit(Tcl_Interp * interp) {
// ~~~~~ INITIALISATION
  cout <<"   __        __" << endl;
  cout <<"  / /_____ _/ /" << endl;
  cout <<" / __/ __ `/ / " << endl;
  cout <<"/ /_/ /_/ / /  " << endl;
  cout <<"\\__/\\__, /_/   " << endl;
  cout <<"   /____/  0.5" << endl;
  // -- packages
  cout << "PACKAGES:" << endl;
  // tcl
  cout << "   * Tcl initialisation ........ :" << flush;
  if (Tcl_Init(interp) == TCL_ERROR) {
    cout << "Tcl: error!"<< endl;
    return TCL_ERROR;
  }
  cout << "OK" << endl;
  // tk
  cout << "   * Tk initialisation ......... :" << flush;
  if (Tk_Init(interp) == TCL_ERROR) {
    cout << "Tk:  error!"<< endl;
    return TCL_ERROR;
  }
  cout << "OK" << endl;
  cout << "     ... statically(?) ......... :" << flush;
  Tcl_StaticPackage(interp, "Tk", Tk_Init, (Tcl_PackageInitProc *) NULL);
  cout << "OK" << endl;
  // tgl
  cout << "   * Tgl initialisatin ......... :" << flush;
  if (Tcl_Init(interp) == TCL_ERROR) {
    cout << "Tgl: error!"<< endl;
    return TCL_ERROR;
  }
  cout << "OK" << endl;
  cout << "     ... statically(?) ......... :" << flush;
  Tcl_StaticPackage(interp, "Tgl", Tgl_Init, (Tcl_PackageInitProc *) NULL);
  cout << "OK" << endl;
  Tcl_PkgProvide(interp,"Tgl","1.0");
  // globale initialisierung der Hashtables
  cout << "   * Tgl-hashtable creation .... :" << flush;
  hash.interp=interp;
  cout << "OK" << endl;
  cout << "READY" << endl;
  return TCL_OK;
}
void main(int argc,char* argv[])
{
  Tk_Main(argc, argv, &Tcl_AppInit);
}




